# Source Generated with Decompyle++
# File: in.pyc (Python 2.4)

'''Convert a NT pathname to a file URL and vice versa.'''

def url2pathname(url):
    '''Convert a URL to a DOS path.

            ///C|/foo/bar/spam.foo

                    becomes

            C:\\foo\\bar\\spam.foo
    '''
    import string as string
    import urllib as urllib
    if '|' not in url:
        if url[:4] == '////':
            url = url[2:]
        
        components = url.split('/')
        return urllib.unquote('\\'.join(components))
    
    comp = url.split('|')
    if len(comp) != 2 or comp[0][-1] not in string.ascii_letters:
        error = 'Bad URL: ' + url
        raise IOError, error
    
    drive = comp[0][-1].upper()
    components = comp[1].split('/')
    path = drive + ':'
    for comp in components:
        if comp:
            path = path + '\\' + urllib.unquote(comp)
            continue
    
    return path


def pathname2url(p):
    '''Convert a DOS path name to a file url.

            C:\\foo\\bar\\spam.foo

                    becomes

            ///C|/foo/bar/spam.foo
    '''
    import urllib
    if ':' not in p:
        if p[:2] == '\\\\':
            p = '\\\\' + p
        
        components = p.split('\\')
        return urllib.quote('/'.join(components))
    
    comp = p.split(':')
    if len(comp) != 2 or len(comp[0]) > 1:
        error = 'Bad path: ' + p
        raise IOError, error
    
    drive = urllib.quote(comp[0].upper())
    components = comp[1].split('\\')
    path = '///' + drive + '|'
    for comp in components:
        if comp:
            path = path + '/' + urllib.quote(comp)
            continue
    
    return path

